import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class MarioBomberman here.
 * 
 * @author Arnulfo Muro Alejos 
 * @version 1.0
 */
public class Bow  extends Actor
{
    private int avance;
    private int dir;
    private int dirImagen;
    private int contImagen;
    private int cont;
    
    public Bow()
    {
        avance = 1;
        dir= Greenfoot.getRandomNumber(4);
        cont = 0;
    }
    
    /**
     * Mueve al objeto, lo anima, checa si es tocado por la explosion y si es cierto se remueve
     * 
     */
    public void act() 
    {
        mueve(dir);

        if(cont == 200)
        {
           dir= Greenfoot.getRandomNumber(4);
           cont = 0;
        }
        cont++;
        
        FlamaHR hr= (FlamaHR) getOneIntersectingObject(FlamaHR.class);
        FlamaHL hl= (FlamaHL) getOneIntersectingObject(FlamaHL.class);
        FlamaVA va= (FlamaVA) getOneIntersectingObject(FlamaVA.class);
        FlamaVB vb= (FlamaVB) getOneIntersectingObject(FlamaVB.class);
        CentroExplosion cE= (CentroExplosion) getOneIntersectingObject(CentroExplosion.class);
        

       
        if(hr != null || hl != null || va != null || vb != null || cE != null)
           getWorld().removeObject(this);
    }    
       
    /**
     * Mueve al objeto en una direccion
     * 
     * @param recibe la direccion en la que debe de avanzar
     */
    private void mueve(int dir){
        
        
        switch(dir) 
         {
             case 0 :
                    {
                        avanza(0, -avance);
                    }
                break;
            case 1 :
                    {
                        avanza(0, avance);
                    }
                break;
            case 2 :
                    {
                        
                        avanza(-avance, 0);
                        setImage("Bowsi.png");

                    }
                break;
            case 3 :
                  {
                        
                        avanza(avance, 0);
                        setImage("Bowsd.png");
                  }
                break;
                
        }
        
    }
    
    /**
     * Mueve al objeto
     * 
     * @param dos enteros que son la direccion
     */
    private void avanza(int x, int y)
      {
        
        
        Pared pared= (Pared) getOneIntersectingObject(Pared.class);
        LadoV ladov= (LadoV) getOneIntersectingObject(LadoV.class);
        Pared2 pared2= (Pared2) getOneIntersectingObject(Pared2.class);
        LadoH ladoh= (LadoH) getOneIntersectingObject(LadoH.class);
        Bomba bomba= (Bomba) getOneIntersectingObject(Bomba.class);
        Bomba2 bomba2= (Bomba2) getOneIntersectingObject(Bomba2.class);
        
        if(pared2==null && ladov==null && ladoh == null && pared2==null && bomba == null && bomba2 == null/*pared.isEmpty()*/)
        {
            setLocation(getX()+x,getY()+y);
        }
        
        pared= (Pared) getOneIntersectingObject(Pared.class);
        ladov= (LadoV) getOneIntersectingObject(LadoV.class);
        pared2= (Pared2) getOneIntersectingObject(Pared2.class);
        ladoh= (LadoH) getOneIntersectingObject(LadoH.class);
        bomba= (Bomba) getOneIntersectingObject(Bomba.class);
        bomba2= (Bomba2) getOneIntersectingObject(Bomba2.class);
        
        if(pared2!=null  || ladov!=null || ladoh != null || pared!=null || bomba != null || bomba2 != null/*!pared.isEmpty()*/)
        {
            setLocation(getX()-x,getY()-y);
            dir= Greenfoot.getRandomNumber(4);
        }
        
    }
}
