import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.List;
/**
 * Write a description of class MarioBomberman here.
 * 
 * @author Arnulfo Muro Alejos 
 * @version 1.0
 */
public class Explosion  extends Actor
{
        
    /**
     * Crea una explosion
     * 
     */
    public void act() 
    {
        // Add your action code here.
        List mario=  getWorld().getObjects(Mario.class);

       
       if(!mario.isEmpty())
       {
           Mario m = (Mario) mario.get(0);
           creaExplosion2(m.getNB(), m.nivelFlamaS());
           getWorld().removeObject(this);
       }
        
        
        
    }
    
    /**
     * Crea una explosion
     * 
     * @param dos referencias una entera que da el nivel de la explosion y otra boolean que es el tipo de explosion
     */
    public void creaExplosion2(int nivel, boolean m)
    {
       
        boolean r = true;
        boolean l = true;
        boolean a = true;
        boolean b = true;
        List pared;
        List pared2;
        List bomba;
        List bomba2;
        List cE;
        int x = getX();
        int y = getY();
        int gxr = x;
        int gxl = x;
        int gya = y;
        int gyb = y;
        
        
        for(int i = 0; i < nivel; i++)
        {
            gxr += 55;
            gxl -= 55;
            gya -= 55;
            gyb += 55;
            
            pared = getWorld().getObjectsAt( gxr, y,Pared.class);
            pared2 = getWorld().getObjectsAt( gxr, y,Pared2.class);
            cE = getWorld().getObjectsAt( gxr, y,CentroExplosion.class);
            bomba = getWorld().getObjectsAt( gxr, y,Bomba.class);
            bomba2 = getWorld().getObjectsAt( gxr, y,Bomba2.class);
            
            if(pared.isEmpty() && gxr < 495 && r)
            {
               
                
                getWorld().addObject(new FlamaHL(), gxr, y);
                
                if(!cE.isEmpty() || !bomba.isEmpty() || !bomba2.isEmpty())
                {
                    r = false;
                }
                
                if(!m)
                {
                    if(!pared2.isEmpty())
                    {
                        r = false;
                    }
                }
                
            }
            if(!pared.isEmpty())
               r = false;
                 
               
            pared = getWorld().getObjectsAt( gxl, y,Pared.class);
            pared2 = getWorld().getObjectsAt( gxl, y,Pared2.class);
            cE = getWorld().getObjectsAt( gxl, y,CentroExplosion.class);
            bomba = getWorld().getObjectsAt( gxl, y,Bomba.class);
            bomba2 = getWorld().getObjectsAt( gxr, y,Bomba2.class);
            
            if(pared.isEmpty() && gxl > 0 && l)
            {
               
                
                getWorld().addObject(new FlamaHR(), gxl, y);
                
                if(!cE.isEmpty() || !bomba.isEmpty() || !bomba2.isEmpty())
                {
                    l = false;
                }
                
                if(!m)
                {
                    if(!pared2.isEmpty())
                    {
                        l = false;
                    }
                }
                
            }
            
            if(!pared.isEmpty())
               l = false;
            

            
            pared = getWorld().getObjectsAt( x, gya,Pared.class);
            pared2 = getWorld().getObjectsAt( x, gya,Pared2.class);
            cE = getWorld().getObjectsAt( x, gya,CentroExplosion.class);
            bomba = getWorld().getObjectsAt( x, gya,Bomba.class);
            bomba2 = getWorld().getObjectsAt( gxr, y,Bomba2.class);
            
            if(pared.isEmpty() && gya > 0 && a)
            {
               
                
                getWorld().addObject(new FlamaVA(), x, gya);
                
                if(!cE.isEmpty() || !bomba.isEmpty() || !bomba2.isEmpty())
                {
                    a = false;
                }
                
                if(!m)
                {
                    if(!pared2.isEmpty())
                    {
                        a = false;
                    }
                }
                
            }
            if(!pared.isEmpty())
               a= false;
            

            
            pared = getWorld().getObjectsAt( x, gyb,Pared.class);
            pared2 = getWorld().getObjectsAt( x, gyb,Pared2.class);
            cE = getWorld().getObjectsAt( x, gyb,CentroExplosion.class);
            bomba = getWorld().getObjectsAt( x, gyb,Bomba.class);
            bomba2 = getWorld().getObjectsAt( gxr, y,Bomba2.class);
            
            if(pared.isEmpty() && gyb < 495 && b)
            {
               
                
                getWorld().addObject(new FlamaVB(), x, gyb);
                
                if(!cE.isEmpty() || !bomba.isEmpty() || !bomba2.isEmpty())
                {
                    b = false;
                }
                
                if(!m)
                {
                    if(!pared2.isEmpty())
                    {
                        b = false;
                    }
                }
                
            }
            if(!pared.isEmpty())
               b= false;
            
        }
        
        r = true;
        l = true;
        a = true;
        b = true;
    }
    
    
    
    
    
    
    
   /* public void creaExplosion(int nivel)
    {
        creaFlamas(getX(), getY(), nivel, 1, 55, 0);
    }
    
    
    
    private void creaFlamas(int xx, int yy, int nivel, int tipo, int gx, int gy)
    {
        List pared;
        List pared2;
        int x = xx + gx;
        int y = yy + gy;
        boolean t = true;
        
        pared = getWorld().getObjectsAt( x, y,Pared.class);
        
        
        
        if(pared.isEmpty() && x > 0 && x < 495 && y > 0 && y < 495)
        {
            agregaFlama(tipo, x, y);
            if(!pared.isEmpty())
               t = false;
               
               x += gx;
               y += gy;
               
               pared = getWorld().getObjectsAt( x, y,Pared.class);
               pared2 = getWorld().getObjectsAt( x, y,Pared2.class);
               
               if(pared.isEmpty() && x > 0 && x < 495 && y > 0 && y < 495 && t && nivel > 1 && pared.isEmpty())
               {
                   agregaFlama(tipo, x, y);
                   if(!pared.isEmpty())
                      t = false;
                      
                      x += gx;
                      y += gy;
               
                      pared = getWorld().getObjectsAt( x, y,Pared.class);
                      pared2 = getWorld().getObjectsAt( x, y,Pared2.class);
               }
               
        }
    }
   
    private void agregaFlama(int tipo, int x, int y)
    {
        if(tipo == 1)
        {
            getWorld().addObject(new FlamaHL(), x, y); 
        }
        if(tipo == 2)
        {
            getWorld().addObject(new FlamaHR(), x, y); 
        }
        if(tipo == 3)
        {
            getWorld().addObject(new FlamaVA(), x, y);
        }
        if(tipo == 4)
        {
            getWorld().addObject(new FlamaVB(), x, y);
        }
    }
    */
    
    
    
    
}