import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class MarioBomberman here.
 * 
 * @author Arnulfo Muro Alejos 
 * @version 1.0
 */
public class Wario  extends Actor
{
   
    private int avance;
    private int dir;
    private int dirImagen;
    private int contImagen;
    private int cont2;
    
    public Wario()
    {
        avance = 2;
        dir= Greenfoot.getRandomNumber(4);
        dirImagen = 1;
        contImagen = 0;
        cont2 = 0;
    }
    
    /**
     * Mueve al objeto, lo anima, checa si es tocado por la explosion y si es cierto se remueve
     * 
     */
    public void act() 
    {
        mueve(dir);
        anima();
        contImagen++;
        
        if(contImagen == 10)
        {
           contImagen = 0;
        }
        
        if(cont2 == 100)
        {
           dir= Greenfoot.getRandomNumber(4);
           cont2 = 0;
        }
        cont2++;
        
        FlamaHR hr= (FlamaHR) getOneIntersectingObject(FlamaHR.class);
        FlamaHL hl= (FlamaHL) getOneIntersectingObject(FlamaHL.class);
        FlamaVA va= (FlamaVA) getOneIntersectingObject(FlamaVA.class);
        FlamaVB vb= (FlamaVB) getOneIntersectingObject(FlamaVB.class);
        CentroExplosion cE= (CentroExplosion) getOneIntersectingObject(CentroExplosion.class);
        

       
        if(hr != null || hl != null || va != null || vb != null || cE != null)
           getWorld().removeObject(this);
    }    
    
    /**
     * Anima al objeto
     * 
     */
    private void anima()
    {
        switch(contImagen) 
         {
             case 0 :
                    {
                        if(dirImagen == 0)
                         setImage("w0.png");
                         else
                           setImage("w00.png");
                    }
                break;
            case 1 :
                    {
                        if(dirImagen == 0)
                         setImage("w1.png");
                         else
                           setImage("w01.png");
                    }
                break;
            case 2 :
                    {
                        if(dirImagen == 0)
                         setImage("w2.png");
                         else
                           setImage("w02.png");
                    }
                break;
            case 3 :
                  {
                      if(dirImagen == 0)
                         setImage("w3.png");
                         else
                           setImage("w03.png");
                  }
                break;
            case 4 :
                    {
                        if(dirImagen == 0)
                         setImage("w4.png");
                         else
                           setImage("w04.png");
                    }
                break;
            case 5 :
                    {
                        if(dirImagen == 0)
                         setImage("w5.png");
                         else
                           setImage("w05.png");
                    }
                break;
            case 6 :
                  {
                      if(dirImagen == 0)
                         setImage("w6.png");
                         else
                           setImage("w06.png");
                  }
                break;
            case 7 :
                    {
                        if(dirImagen == 0)
                         setImage("w7.png");
                         else
                           setImage("w07.png");
                    }
                break;
            case 8 :
                    {
                        if(dirImagen == 0)
                         setImage("w8.png");
                         else
                           setImage("w08.png");
                    }
                break;
            case 9 :
                  {
                      if(dirImagen == 0)
                         setImage("w9.png");
                         else
                           setImage("w09.png");
                  }
                break;
                
        }
    }
    
    
    /**
     * Mueve al objeto en una direccion
     * 
     * @param recibe la direccion en la que debe de avanzar
     */
    private void mueve(int dir){
        
        
        switch(dir) 
         {
             case 0 :
                    {
                        avanza(0, -avance);
                    }
                break;
            case 1 :
                    {
                        avanza(0, avance);
                    }
                break;
            case 2 :
                    {
                        
                        avanza(-avance, 0);
                        dirImagen = 1;

                    }
                break;
            case 3 :
                  {
                        
                        avanza(avance, 0);
                        dirImagen = 0;
                  }
                break;
                
        }
        
    }
    
    /**
     * Mueve al objeto
     * 
     * @param dos enteros que son la direccion
     */
    private void avanza(int x, int y)
      {
        
        
        Pared pared= (Pared) getOneIntersectingObject(Pared.class);
        LadoV ladov= (LadoV) getOneIntersectingObject(LadoV.class);
        Pared2 pared2= (Pared2) getOneIntersectingObject(Pared2.class);
        LadoH ladoh= (LadoH) getOneIntersectingObject(LadoH.class);
        Bomba bomba= (Bomba) getOneIntersectingObject(Bomba.class);
        Bomba2 bomba2= (Bomba2) getOneIntersectingObject(Bomba2.class);
        
        if(pared2==null && ladov==null && ladoh == null && pared2==null && bomba == null && bomba2 == null/*pared.isEmpty()*/)
        {
            setLocation(getX()+x,getY()+y);
        }
        
        pared= (Pared) getOneIntersectingObject(Pared.class);
        ladov= (LadoV) getOneIntersectingObject(LadoV.class);
        pared2= (Pared2) getOneIntersectingObject(Pared2.class);
        ladoh= (LadoH) getOneIntersectingObject(LadoH.class);
        bomba= (Bomba) getOneIntersectingObject(Bomba.class);
        bomba2= (Bomba2) getOneIntersectingObject(Bomba2.class);
        
        if(pared2!=null  || ladov!=null || ladoh != null || pared!=null || bomba != null || bomba2 != null/*!pared.isEmpty()*/)
        {
            setLocation(getX()-x,getY()-y);
            dir= Greenfoot.getRandomNumber(4);
        }
        
    }
}
