import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class MarioBomberman here.
 * 
 * @author Arnulfo Muro Alejos 
 * @version 1.0
 */
public class Bomba  extends AnimatedActor
{
    private int cont;
    
    public Bomba()
    { 
        
        super("b", ".png",20);
    }
    
    
    /**
     * Crea una explosion despues de acuar 120 veces o si es tocado por una flama,
     * y despues se remueve
     */
    public void act() 
    {
       
        FlamaHR hr= (FlamaHR) getOneIntersectingObject(FlamaHR.class);
        FlamaHL hl= (FlamaHL) getOneIntersectingObject(FlamaHL.class);
        FlamaVA va= (FlamaVA) getOneIntersectingObject(FlamaVA.class);
        FlamaVB vb= (FlamaVB) getOneIntersectingObject(FlamaVB.class);
        CentroExplosion cE= (CentroExplosion) getOneIntersectingObject(CentroExplosion.class);
        
        
        super.act();
        if((cont++) == 120 || hr != null || hl != null || va != null || vb != null || cE != null)
        {
            Greenfoot.playSound("explosion.wav");
            getWorld().addObject(new CentroExplosion(), getX(), getY());
            getWorld().addObject(new Explosion(), getX(), getY());
            getWorld().removeObject(this);  
        }
        
    }    
    
    
}
